var contact = null;

var myContacts;

var loadContacts = function(){
	var options = new ContactFindOptions();
	options.filter = "";
	options.multiple = true;
	var contactFields = ["name", "phoneNumbers"];
	
	$("#txtGivenName").val("");
	$("#txtFamilyName").val("");
	$("#txtMobilePhone").val("");
	$("#txtHomePhone").val("");
	$("#txtWorkPhone").val("");	
	
	navigator.contacts.find(contactFields, onSuccess, onError, options);
}

var selectList = function(idx){
	$("#title").text("수정/삭제할 연락처 인덱스 : "+(idx+1));
	
	contact = myContacts[idx];
	var contactName = contact.name;
	$("#txtGivenName").val(contactName.givenName);
	$("#txtFamilyName").val(contactName.familyName);
	$("#txtMobilePhone").val("");
	$("#txtHomePhone").val("");
	$("#txtWorkPhone").val("");
	
	for (var k = 0; k < contact.phoneNumbers.length; k++){
		var phone = contact.phoneNumbers[k];
		if(phone.type =='mobile') $("#txtMobilePhone").val(phone.value);
		else if(phone.type =='home') $("#txtHomePhone").val(phone.value);
		else $("#txtWorkPhone").val(phone.value);
	}
}

// 연락처 추가
var addContact = function(){
	contact = navigator.contacts.create();
	
	var contactName = new ContactName();
	contact.name = contactName;
	
	var phone = [3];
	contact.phoneNumbers = phone;
	
	var givenName = $("#txtGivenName").val();
	var familyName = $("#txtFamilyName").val();
	var mobilePhone = $("#txtMobilePhone").val();
	var homePhone = $("#txtHomePhone").val();
	var workPhone = $("#txtWorkPhone").val();
	
	contact.name.givenName = givenName;
	contact.name.familyName = familyName;
	
	var idx = 0;
	if(mobilePhone.length > 0){
		contact.phoneNumbers[idx] = new ContactField('mobile',mobilePhone,false);
		idx ++;
	}
	if(homePhone.length > 0){
		contact.phoneNumbers[idx] = new ContactField('home', homePhone, false);
		idx ++;
	}
	if(workPhone.length > 0){
		contact.phoneNumbers[idx] = new ContactField('work', workPhone, false);
	}
	
	contact.save(onContactSuccess, onErrorMsg);
}

//연락처 수정
var updateContact = function(){
	if(contact == null) {
		$("#title").text("수정할 연락처 선택요망!!");
	}else{
		contact.remove(addContact, onErrorMsg);	
	}
}


//연락처 삭제
var delContact = function(){
	if(contact == null){
		$("#title").text("삭제할 연락처 선택요망!!");
		return;
	}
	//remove 메소드는 하나의 연락처를 삭제하는 메소드이다.
	//remove(삭제시 성공했을 때 콜백함수, 삭제시 실패했을 때 콜백함수)
	contact.remove(onContactSuccess, onErrorMsg);
}

var onContactSuccess = function(receivedContact){
	contact = null;
	//contact = receivedContact;
	
	loadContacts();
}



var onErrorMsg = function(msg){
	$("#title").text("Error: "+msg);
}


var onSuccess =function(contact){
	myContacts = contact;	
	var temp = "";
	var msg = "연락처 수 : "+contact.length;
	$("#title").text(msg);
	$("#contactList").text("");	
	
	for(var i = 0; i<contact.length; i++){
		var cName = contact[i].name;
		msg = "이름 : "+cName.familyName + cName.givenName;
		
		for(var j=0; j<contact[i].phoneNumbers.length; j++){
			var phone = contact[i].phoneNumbers[j];
			msg +="<br/>Phone: "+phone.type+": "+phone.value;
		} //end of for	
		
		
		/* if(contact[i].phoneNumbers != null && contact[i].phoneNumbers.length > 0){
			temp = "<li>"+contact[i].name.givenName+":"+contact[i].displayName+":"+"010-1234-1234"+"</li>"; 
		*/
			temp = "<li><a href='javascript:selectList("+i+")'>"+msg+"</a></li>";
			
			$("#contactList").append(temp);
		}//end of for문	
	
	$("#contactList").listview("refresh");
}


var onError = function(message){
	alert(message);
}

var onDeviceReady = function(){
	loadContacts();
	
	$("#createBtn").tap(function(){
		/* contact = navigator.contacts.create();
		var contactName = new ContactName();
		contact.name = contactName;
		contact.name.givenName = "말똥";
		contact.name.familyName = "고";
		var phone = [1];
		contact.phoneNumbers = phone;
		contact.phoneNumbers[0] = new ContactField('mobile', '010-4545-4555', false);  */
		
		/* var contact = 			  navigator.contacts.create({"name":"개똥","displayName":"김개똥","nickname":"개똥이"}); */
		contact.save(
		function(){alert("저장완료")},
		function(){alert("저장실패")}
		);
		
	});	
	
	$("#findBtn").tap(function(){
		var options = new ContactFindOptions();
		options.filter = "김말똥"
		//options.multiple = true;
		var fields =["name", "displayName", "nickname"];
		navigator.contacts.find(fields, onSuccess, onError, options);
		
	});
	
	$("#add").tap(addContact);
	$("#del").tap(delContact);
	$("#update").tap(updateContact);
	
}



var init = function(){
	document.addEventListener("deviceready", onDeviceReady, false);
}

$(document).ready(init);
