/********************************************************

var myFS;
var myDE; //DirectoryEntry객체를 저장하는 멤버변수

var onDeviceReady = function(){
	    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, onGetFS, onFail);
		$("#makeBtn").tap(makeDir);
		$("#removeBtn").tap(delDir);
		$("#copyBtn").tap(copyFile); 
}

var onGetFS = function(fs){
	myFS = fs;
	myDE = myFS.root; //FileSystem.root는 공용저장공간의 루트 디렉토리를 반환한다. 타입은 DirectoryEntry이다.
	readFileList();
}

//파일목록을 구해서 화면에 표시하는 함수
var readFileList = function(){
	//파일목록을 구하기 위해서는 DirectoryReader 객체가 필요함.
	//DirectoryReader 객체는 DirectoryEntry.createReader()를 이용해서 DirectoryReader객체를 구한다.
    //DirectoryReader.readEntries(success, error)함수는 파일목록을 요청하는 함수이다.	
	myDE.createReader().readEntries(onGetEntries, onFail);
}

var onGetEntries = function(entries){
	//entries 라는 인자는 파일 및 폴더 목록을 배열로 저장하고 있다.
	
	var txtTag;
	var linkVal;
	
	$("#message").text(myDE.fullPath);
	$("#listFile").text("");
	
	//현재 디렉토리가 루트인지 아닌지를 체크하고, 화면에 표시
	if(myDE.fullPath != myFS.root.fullPath){		
		linkVal = "javascript:chdir('..');"; 		
		txtTag = '<li><a href="'+linkVal+'">..</a></li>'; 		
		$("#listFile").append(txtTag);
	}
	
	//현재의 디렉토리내에 엔트리(목록)가 있으면 화면에 출력, 없으면 수행하지 않는다.
	for (var i = 0; i < entries.length; i++){
		if(entries[i].isFile) // Entry.isFile은 이객체가 파일인지 폴더인지를 구분하는 역할을 한다. true이면 파일이다.
			txtTag = '<li><a href="#">'+entries[i].name+'</a></li>';
		else{
			console.log(entries[i].name);	
			linkVal = "javascript:chdir('"+entries[i].name+"');";
			txtTag = '<li><a href="'+linkVal+'">'+entries[i].name+'</a></li>';
		}
		
		$("#listFile").append(txtTag);
	} 	
	$("#listFile").listview("refresh");
} 

var chdir = function(dir){
	if(dir == "..")
		// DirectoryEntry.getParent(success, error) : 현재 경로에서 상위폴더의 DirectoryEntry객체를 요청하는 함수이다.
		myDE.getParent(onGetDir, onFail); 
	else
		 // DirectoryEntry.getDirectory(path, Flags, success, error): 현재의 경로에서
	       // 하위폴더의 DirectoryEntry객체를 요청하는 함수이다. 이함수를 이용할 경우에는
 		   // 새로운 폴더를 생성할 수도 있다. 
			// - 첫번째 파라미터는 string 형식으로 지정
			// - 두번째 파라미터는 폴더가 존재하지 않을 경우 생성할 지 여부를 지정한다.
			  // JSON 형태로 속성을 지정한다. 
			  // create : true 면 폴더가 존재하지 않을 경우에는 새로 생성하겠다. 폴더가 존재하면 새로 생성하지 않겠다  
			  // exclusive : true 이면 폴더가 존재하더라도 무시하고 새로 생성한다. 
			  // create:true 일때 의미가 있다.
			// - 세번째 네번째 파라미터는 각각 성공, 실패 할경우의 콜백함수
		
	    
		myDE.getDirectory(dir, {}, onGetDir, onFail);	
}

var onGetDir = function(de){
	myDE = de;
	readFileList();
}

var makeDir = function(){
	myFS.root.getDirectory("testFolder", {create:true, exclusive:false}, onGetDir, onFail);
}

var delDir = function(){
	// 폴더를 삭제하는함수 2가지
	// DirectoryEntry.remove(success, error) : 삭제 하고자하는 폴더가 비어있을때만 폴더를 삭제하는 함수이다.
	// DircetoryEntry.removeRecursively(success, error) :삭제하고자 하는 폴더와 그 폴더 안에 있는 모든 파일 및 서브 폴더까지 삭제하는 함수
	myDE.removeRecursively(onSuccess, onFail);
	myDE = myFS.root;
}


var copyFile = function(){
	myFS.root.getFile("test.txt",{create:true, exclusive: false},
		function(fe) {
			// 파일복사 함수
			// FileEntry.copyTo(parent, newName, success, error)
			// 첫번째 인자 : 복사할 경로를 지정하기 위해 DirectoryEntry객체를 지정한다.
			// 두번째 인자 : 새로운 파일명을 지정하기
			// 세번째, 네번째 인자 : 각각 복사의 성공/실패 시 호출하는 함수
			// 파일 이동함수
			// FileEntry.moveTo(parent, newName, success, error)
			fe.copyTo(myDE, "test.txt", onSuccess, onFail);
		}, onFail);
}

var onSuccess = function(fe){
	readFileList();
}

var onFail = function(msg){
	$("#message").text("에러코드 : "+msg.code);
}

var init = function(){
	document.addEventListener('deviceready', onDeviceReady, false);
} 
****************************************************/

/////////////// LocalStorage 사용하기 ////////////////

/* var init = function(){
	document.addEventListener("deviceready", onDeviceReady, true);
}

var onDeviceReady = function(){
	loadKeyList();
	$("#saveBtn").tap(saveList);
	$("#readBtn").tap(readList);
	$("#delBtn").tap(delList);
}

var isKey = function(key){
	var flag = false;
		for(var i= 0; i <window.localStorage.length; i++){
			var sKey = window.localStorage.key(i);
			if(key == sKey) flag=true;
		}
	if(!flag) alert("키가 존재하지 않습니다. 확인 바랍니다.!!");		
}

var delList = function(){
	var key = $("#textKey").val();
	if(key == "") alert("키값을 입력하세요!!");
	else{
		isKey(key);	
	}		
	//삭제함수
	//window.localStorage.removeItem(key): 키에 해당하는 데이터를 삭제하는 함수
	window.localStorage.removeItem(key);
	$("#textKey").val("");
	loadKeyList();
}

var readList = function(){
	var key = $("#textKey").val();
	if(key == "") alert("키값을 입력하세요!!");
	else{
		isKey(key);
	}		
	
	var value = window.localStorage.getItem(key);
	$("#textValue").val(value);
	
}

var saveList = function(){
	
	var key = $("#textKey").val();
	var value =$("#textValue").val();	
	//localStorage에 새로운 데이터를 저장하는 함수
	//window.localStorage.setItem(key, value) : 두개의 key, value값이 한쌍이 되어 데이터를 구성
	window.localStorage.setItem(key, value);
	$("#textKey").val("");
	$("#textValue").val("");
	loadKeyList();
}


var loadKeyList = function(){
	//window.localStorage는 로컬 데이터 저장소 객체이다.
	//localStorage에 저장되어 있는 데이터 목록 구하기
	//window.localStorage.length 속성은 데이터 목록 개수를 구해서 메시지 문자열 추가한다.
	//window.localStorage.key(index)는 index 번호에 해당하는 항목의 키값을 반환하는 함수
	//window.localStorage.getItem(key) key에 대응하는 value값을 반환하는 함수 
	
	var msg = "# 데이터 리스트 - 갯수 : "+window.localStorage.length;
	for(var i=0; i < window.localStorage.length; i++){
		msg += "<br/>";
		var key = window.localStorage.key(i);
		var value = window.localStorage.getItem(key);
		msg += key + " : "+ value;
	}
	$("#message").html(msg);
} */

//////////////////////////////////////////////////////


//////////////////로컬 DB 사용하기////////////////////

//SQL 쿼리문을 전송하기 위해서는 SQLTransaction객체가 필요하다.
//SQLTransaction객체는 Database객체를 통해서 얻을 수 있다.

//SQLTransaction객체는 SQL쿼리문을 전달받아서 테이블을 생성하과, 레코드를 추가/수정/삭제와 같은 기능을 수행한다.

var db; //데이터베이스 객체를 저장하는 변수
var dataList = null; //모든 레코드의 정보가 저장된 배열 객체
var maxId; //레코드의 ID 값 중에서 최대값을 저장해 두는 변수
var selectedId; //현재 사용자가 선택한 레코드의 ID값을 저장해 두는 변수

var init = function(){
	document.addEventListener("deviceready", onDeviceReady, true);
}

var onDeviceReady = function(){
	//데이터베이스를 여는 함수
	openDB();
	createTable();
	$("#insertBtn").tap(insertRecord);
    $("#updateBtn").tap(updateRecord);
	$("#deleteBtn").tap(deleteRecord);
    $("#resetBtn").tap(clearInput);	
}

var cname, ckor, cenglish, cmath;

var deleteRecord = function(){	
	checkInputBox();
	if(cname =="" || ckor =="" || cenglish =="" || cmath=="" ) {
		alert("처리하고자 하는 데이터를 다시 확인 하세요!!");
		return;
	}
	db.transaction(function(ST){
		var sql = "DELETE FROM ReportCard WHERE id = ?";
		ST.executeSql(sql, [selectedId], onSuccess, errorDB);
	}, errorDB);
}

var checkInputBox = function(){
	cname = $("#textName").val();	
	ckor = $("#textKor").val();
	cenglish = $("#textEnglish").val();
	cmath = $("#textMath").val();
}

var updateRecord = function(){
	checkInputBox();
	if(cname =="" || ckor =="" || cenglish =="" || cmath=="" ) {
		alert("처리하고자 하는 데이터를 다시 확인 하세요!!");
		return;
	}
	db.transaction(function(ST){
		var name = $("#textName").val();
		var kor = $("#textKor").val();
		var english = $("#textEnglish").val();
		var math = $("#textMath").val();
		
		var sql = "UPDATE ReportCard SET name=? , kor=?, english=?, math=? WHERE id=?";
		
		ST.executeSql(sql, [name, kor, english, math, selectedId], onSuccess, errorDB);
		
	},errorDB);
}

/* SQL DML문 형식
	- SELECT 필드명/* FROM 테이블명
	- INSERT INTO 테이블명 (필드...) VALUES(값1, 값2,....)
	- UPDATE 테이블명 SET 필드명 = 수정값
	- DELETE FROM 테이블명 WHERE 필드명(컬럼명) = 값
 */

var insertRecord = function(){
	checkInputBox();
	if(cname =="" || ckor =="" || cenglish =="" || cmath=="" ) {
		alert("처리하고자 하는 데이터를 다시 확인 하세요!!");
		return;
	}
	db.transaction(function(ST){
						var name = $("#textName").val();
						var kor = $("#textKor").val();
						var english = $("#textEnglish").val();
						var math = $("#textMath").val();
						
						var id = maxId + 1;
						
						var sql = "INSERT INTO ReportCard (id, name, kor, english, math) VALUES(?,?,?,?,?)";
						
						ST.executeSql(sql,[id, name, kor, english, math], onSuccess, errorDB);
				   }, errorDB);
}


var openDB = function(){
	//Database 객체를 구하기
	//window.openDatabase(name, version, display_name, size)는 Database객체를 생성해서 반환하는 함수이다.
	
	//첫번째 인자 : 데이터베이스 이름
	//두번재 인자 : 데이터베이스 버전을 지정하기
	//세번째 인자 : 데이터베이스 표시이름 지정하기
	//네번째 인자 : 데이터베이스의 용량을 지정한다.(단위는 byte) 
	db = window.openDatabase("ReportCard", "1.0", "DB Example", 1000000);
	var msg = "DisplayName: "+db.display_name + " / Name: "+db.name+ " / version"
							+db.version + "/ size: "+db.size;
	$("#message").text(msg);
}

var createTable = function(){
	// SQLTransaction 객체를 요청하는 함수
	// Database.transaction(executeSQL, error)은 SQL 쿼리문을 수행하기 위해서 SQLTransaction객체를 요청한다.
	
	//첫번째 인자 : SQL쿼리문을 실행하는 함수를 콜백함수로 지정하는 인자
	//두번재 인자 : SQLTransaction 객체 요청을 실패했을 때 콜백함수 지정
	
	//테이블을 생성하는 SQL문
	// CREATE TABLE IF NOT EXISTS ReportCard(id unique, name, kor, english, math);
	
	//SQLTransaction.executeSql(sqlStatement,[arguments],[success],[error]):SQL 쿼리문을 수행하는 함수
	// 첫번째 인자 : 실제 수행할 SQL 쿼리문을 전달
	// 두번째 인자 : 새로 입력될 레코드의 내용을 지정(생략가능)
	// 세번째 인자 : SQL 쿼리문을 성공적으로 수행 했을 때 콜백함수를 지정하는 인자
	// 네번째 인자 : SQL 쿼리문 실행시 실패했을 때 콜백함수를 지정하는 인자
	
	db.transaction(function(ST){
					var sql = "CREATE TABLE IF NOT EXISTS ReportCard "	
					         +"(id uique, name, kor, english, math)";
					ST.executeSql(sql,[],onSuccess);		 
	              }, errorDB);
}

var onSuccess = function(ST, SQLResultSet){
	$("#message").text("SQLTransaction 요청 성공!!");
	loadList();
}

var loadList = function(){
	db.transaction(function(ST){
					 var sql = "SELECT * from ReportCard";
					 ST.executeSql(sql, [], selectSuccess ,errorDB);		
				   }, errorDB);
	clearInput();			   
}

var clearInput = function(){
	$("#textName").val("");
	$("#textKor").val("");
	$("#textEnglish").val("");
	$("#textMath").val("");
}

var selectSuccess = function(ST, sqlResultSet){
	//SQLResultSet 객체 : 모든 레코드의 데이터를 정상적으로 구했을 때, 그데이터를 저장하는 객체
	//SQLResultSet.rows : 쿼리문의 실행 결과로 얻어온 모든 데이터가 저장된 객체를 반환
	
	dataList = sqlResultSet.rows;
	$("#message").text("Recode 갯수 : " +dataList.length);
	var msg = "";
	$("#listReport").text("");
	
	maxId = 0;
	for(var i=0; i<dataList.length; i++){
		//ID의 최대값을 구하겠다.
		if(dataList.item(i)["id"] != undefined ){
			if(maxId < dataList.item(i)["id"])
				maxId = dataList.item(i)["id"]; 
		}
		kor = parseInt(dataList.item(i)["kor"]);
		english = parseInt(dataList.item(i)["english"]);
		math = parseInt(dataList.item(i)["math"]);
		
		msg = "#Name : " + dataList.item(i)["name"]
		      + "<br/>국어 : "+ kor
			  + "/ 영어 : "+ english
			  + "/ 수학 : "+ math 
	          + "<br/>** 평균 :"+((kor+english+math)/3);
		
		itemTag = '<li><a href="javascript:onListSelected('+i+')">'+msg+'</a></li>'
		$("#listReport").append(itemTag);
	} //end of For문
	$("#listReport").listview("refresh");
}
var onListSelected = function(index){
	selectedId = dataList.item(index)["id"];	
	$("#textName").val(dataList.item(index)["name"]);
	$("#textKor").val(dataList.item(index)["kor"]);
	$("#textEnglish").val(dataList.item(index)["english"]);
	$("#textMath").val(dataList.item(index)["math"]);
}

var errorDB = function(sqlError){
	// SQLError.code 오류 코드의 종류
	
	// SQLError.code.UNKNOWN_ERR : 알 수 없는 오류
	// SQLError.code.DATABASE_ERR : 데이터베이스 오류
	// SQLError.code.VERSION_ERR : 버전 오류
	// SQLError.code.TOO_LARGE_ERR : SQL 문장이 너무 길어서 해독 불가 오류
	// SQLError.code.QUOTA_ERR : 용량초과
	// SQLError.code.SYNTAX_ERR : SQL의 구문 오류
	// SQLError.code.CONSTRAINT_ERR : 제한에 의한 오류
	// SQLError.code.TIMEOUT_ERR : 제한 시간 초과
	
	var msg = "Transaction Error : " + sqlError.code + " / "+sqlError.message;
	$("#message").text(msg);
}


///////////////////////////////////////////////////

$(document).on("pageinit", init); 





